// Generated by N4JS transpiler; for copyright see original N4JS source file.

import 'n4js-runtime'
import {ResultGroup} from './ResultGroup.js'
import {aggregateTestStatuses} from './TestStatus.js'

export class ResultGroups extends N4Object {
	constructor(results) {
		super();
		this.results = undefined;
		this.successes = 0;
		this.failures = 0;
		this.skipped = 0;
		this.errors = 0;
		this.results = results;
		ResultGroups.accumulateResults(this, results);
	}
	aggregate() {
		let result;
		let trMap = new Map();
		let description;
		for(let rg of this.results) {
			description = rg.description;
			for(let tr of rg.testResults) {
				if (trMap.has(tr.description)) {
					let oldTr = trMap.get(tr.description);
					let testStatus = aggregateTestStatuses(tr.testStatus, oldTr.testStatus);
					if (testStatus != oldTr.testStatus) {
						trMap.set(tr.description, tr);
					}
				} else {
					trMap.set(tr.description, tr);
				}
			}
		}
		result = new ResultGroup(Array.from(trMap.values()), description);
		return result;
	}
	static accumulateResults(target, results) {
		for(let result of results) {
			target.successes += result.successes;
			target.failures += result.failures;
			target.errors += result.errors;
			target.skipped += result.skipped;
			if (result instanceof ResultGroups) {
				target.results = target.results.concat(result.results);
			}
		}
		return target;
	}
	static concat(...resultGroups) {
		return this.concatArray(resultGroups);
	}
	static concatArray(resultGroupss) {
		return this.accumulateResults(new ResultGroups([]), (resultGroupss));
	}
	static get n4type() {
		return $getReflectionForClass(this, '["ResultGroups","org/eclipse/n4js/mangelhaft/types/ResultGroups","org.eclipse.n4js.mangelhaft",["f.results","f.successes","f.failures","f.skipped","f.errors"]]');
	}
}
//# sourceMappingURL=ResultGroups.map
